/*=====[ The TesSeRact(TM) CXL User Interface Development System ]======*
 | Copyright (c) 1987-1990, Innovative Data Concepts. All Rights Reserved
 |
 | This Library is part of IDC's TesSeRact Development Tools product
 | line. For information about other IDC products, call 1-215-884-3373.
 *----------------------------------------------------------------------*
 | <TCXLcod.h> : Define mnemonic names for the full set of PC-Compatible
 | non-display control and extended keycodes.
 *-------------------------------[ Notes ]------------------------------*
 | 1) The keycodes marked with '**' are only available on "Enhanced"
 |    keyboards with extended Keyboard BIOS support enabled. In TCXL, the
 |    KextOn() macro enables extended keyboard support and the KextOff()
 |    macro disables it (see <TCXLkey.h>.
 | 2) The ASCI control-code names are shown in [] where applicable. Note
 |    that Ctl-Z [SUB] is defined as an End-Of-File in MS-DOS.
 *----------------------------------------------------------------------*
 | PGS : $Id: tcxlcod.h 5.51 90/10/01 00:00:00 MLM Release Locker: MLM $
 | $Log:	tcxlcod.h $
 | Revision 5.51  90/10/01  00:00:00  MLM
 | TCXL 5.51
 | 
 *======================================================================*/
#ifndef  _TCXLcod_
#  define   _TCXLcod_   1        /*- Normal -------*/
#  define   Key_Esc     0x011B   /*   <Esc>        */
#  define   Key_BS      0x0E08   /*   <BS>         */
#  define   Key_Tab     0x0F09   /*   <Tab>        */
#  define   Key_Ent     0x1C0D   /*   <Enter>      */
#  define   Key_F1      0x3B00   /*   <F1>         */
#  define   Key_F2      0x3C00   /*   <F2>         */
#  define   Key_F3      0x3D00   /*   <F3>         */
#  define   Key_F4      0x3E00   /*   <F4>         */
#  define   Key_F5      0x3F00   /*   <F5>         */
#  define   Key_F6      0x4000   /*   <F6>         */
#  define   Key_F7      0x4100   /*   <F7>         */
#  define   Key_F8      0x4200   /*   <F8>         */
#  define   Key_F9      0x4300   /*   <F9>         */
#  define   Key_F10     0x4400   /*   <F10>        */
#  define   Key_Home    0x4700   /*   <Home>       */
#  define   Key_Up      0x4800   /*   <Up>         */
#  define   Key_PgUp    0x4900   /*   <PgUp>       */
#  define   Key_MinG    0x4A2D   /*   <->Gry       */
#  define   Key_Lft     0x4B00   /*   <Left>       */
#  define   Key_Rgt     0x4D00   /*   <Right>      */
#  define   Key_PlsG    0x4E2B   /*   <+>Gry       */
#  define   Key_End     0x4F00   /*   <End>        */
#  define   Key_Dwn     0x5000   /*   <Down>       */
#  define   Key_PgDn    0x5100   /*   <PgDn>       */
#  define   Key_Ins     0x5200   /*   <Ins>        */
#  define   Key_Del     0x5300   /*   <Del>        */
#  define   Key_F11     0x8500   /*   <F11>     ** */
#  define   Key_F12     0x8600   /*   <F12>     ** */
#  define   Key_EntG    0xE00D   /*   <Enter>Gry** */
                                 /*- Shift --------*/
#  define   Key_S_Tab   0x0F00   /* S <Tab>        */
#  define   Key_S_Home  0x4737   /* S <7>Num 7     */
#  define   Key_S_Up    0x4838   /* S <8>Num 8     */
#  define   Key_S_PgUp  0x4939   /* S <9>Num 9     */
#  define   Key_S_Lft   0x4B34   /* S <4>Num 4     */
#  define   Key_S_Num5  0x4C35   /* S <5>Num       */
#  define   Key_S_Rgt   0x4D36   /* S <6>Num 6     */
#  define   Key_S_End   0x4F31   /* S <1>Num 1     */
#  define   Key_S_Dwn   0x5032   /* S <2>Num 2     */
#  define   Key_S_PgDn  0x5133   /* S <3>Num 3     */
#  define   Key_S_Ins   0x5230   /* S <Ins>  0     */
#  define   Key_S_Del   0x532E   /* S <Del>  1     */
#  define   Key_S_F1    0x5400   /* S <F1>         */
#  define   Key_S_F2    0x5500   /* S <F2>         */
#  define   Key_S_F3    0x5600   /* S <F3>         */
#  define   Key_S_F4    0x5700   /* S <F4>         */
#  define   Key_S_F5    0x5800   /* S <F5>         */
#  define   Key_S_F6    0x5900   /* S <F6>         */
#  define   Key_S_F7    0x5A00   /* S <F7>         */
#  define   Key_S_F8    0x5B00   /* S <F8>         */
#  define   Key_S_F9    0x5C00   /* S <F9>         */
#  define   Key_S_F10   0x5D00   /* S <F10>        */
#  define   Key_S_F11   0x8700   /* S <F11>     ** */
#  define   Key_S_F12   0x8800   /* S <F12>     ** */
                                 /*- Ctl ----------*/
#  define   Key_C_Brk   0x0000   /* C <Break>      */
#  define   Key_C_BS    0x0E7F   /* C <BS>   [DEL] */
#  define   Key_C_Q     0x1011   /* C <q>    [DC1] */
#  define   Key_C_W     0x1117   /* C <w>    [ETB] */
#  define   Key_C_E     0x1205   /* C <e>    [ENQ] */
#  define   Key_C_R     0x1312   /* C <r>    [DC2] */
#  define   Key_C_T     0x1414   /* C <t>    [DC4] */
#  define   Key_C_Y     0x1519   /* C <y>    [EM]  */
#  define   Key_C_U     0x1615   /* C <u>    [NAK] */
#  define   Key_C_I     0x1709   /* C <i>    [HT]  */
#  define   Key_C_O     0x180F   /* C <o>    [SI]  */
#  define   Key_C_P     0x1910   /* C <p>    [DLE] */
#  define   Key_C_Lbr   0x1A1B   /* C <[>    [ESC] */
#  define   Key_C_Rbr   0x1B1D   /* C <]>    [GS]  */
#  define   Key_C_Ent   0x1C0A   /* C <Enter>[LF]  */
#  define   Key_C_A     0x1E01   /* C <a>    [SOH] */
#  define   Key_C_S     0x1F13   /* C <s>    [DC3] */
#  define   Key_C_D     0x2004   /* C <d>    [EOT] */
#  define   Key_C_F     0x2106   /* C <f>    [ACK] */
#  define   Key_C_G     0x2207   /* C <g>    [BEL] */
#  define   Key_C_H     0x2308   /* C <h>    [BS]  */
#  define   Key_C_J     0x240A   /* C <j>    [LF]  */
#  define   Key_C_K     0x250B   /* C <k>    [VT]  */
#  define   Key_C_L     0x260C   /* C <l>    [FF]  */
#  define   Key_C_Bsl   0x2B1C   /* C <\>    [FS]  */
#  define   Key_C_Z     0x2C1A   /* C <z>    [SUB] */
#  define   Key_C_X     0x2D18   /* C <x>    [CAN] */
#  define   Key_C_C     0x2E03   /* C <c>    [ETX] */
#  define   Key_C_V     0x2F16   /* C <v>    [SYN] */
#  define   Key_C_B     0x3002   /* C <b>    [STX] */
#  define   Key_C_N     0x310E   /* C <n>    [SO]  */
#  define   Key_C_M     0x320D   /* C <m>    [CR]  */
#  define   Key_C_F1    0x5E00   /* C <F1>         */
#  define   Key_C_F2    0x5F00   /* C <F2>         */
#  define   Key_C_F3    0x6000   /* C <F3>         */
#  define   Key_C_F4    0x6100   /* C <F4>         */
#  define   Key_C_F5    0x6200   /* C <F5>         */
#  define   Key_C_F6    0x6300   /* C <F6>         */
#  define   Key_C_F7    0x6400   /* C <F7>         */
#  define   Key_C_F8    0x6500   /* C <F8>         */
#  define   Key_C_F9    0x6600   /* C <F9>         */
#  define   Key_C_F10   0x6700   /* C <F10>        */
#  define   Key_C_Lft   0x7300   /* C <Left>       */
#  define   Key_C_Rgt   0x7400   /* C <Right>      */
#  define   Key_C_End   0x7500   /* C <End>        */
#  define   Key_C_PgDn  0x7600   /* C <PgDn>       */
#  define   Key_C_Home  0x7700   /* C <Home>       */
#  define   Key_C_PgUp  0x8400   /* C <PgUp>       */
#  define   Key_C_F11   0x8900   /* C <F11>     ** */
#  define   Key_C_F12   0x8A00   /* C <F12>     ** */
#  define   Key_C_Up    0x8D00   /* C <Up>      ** */
#  define   Key_C_MinG  0x8E00   /* C <->Gry    ** */
#  define   Key_C_5Num  0x8F00   /* C <5>Num    ** */
#  define   Key_C_PlsG  0x9000   /* C <+>Gry    ** */
#  define   Key_C_Dwn   0x9100   /* C <Dwn>     ** */
#  define   Key_C_Ins   0x9200   /* C <Ins>     ** */
#  define   Key_C_Del   0x9300   /* C <Del>     ** */
#  define   Key_C_EntG  0xE00A   /* C <Enter>Gry** */
                                 /*- Alt ----------*/
#  define   Key_A_Esc   0x0100   /* A <Esc>        */
#  define   Key_A_Q     0x1000   /* A <q>          */
#  define   Key_A_W     0x1100   /* A <w>          */
#  define   Key_A_E     0x1200   /* A <e>          */
#  define   Key_A_R     0x1300   /* A <r>          */
#  define   Key_A_T     0x1400   /* A <t>          */
#  define   Key_A_Y     0x1500   /* A <y>          */
#  define   Key_A_U     0x1600   /* A <u>          */
#  define   Key_A_I     0x1700   /* A <i>          */
#  define   Key_A_O     0x1800   /* A <o>          */
#  define   Key_A_P     0x1900   /* A <p>          */
#  define   Key_A_Lbr   0x1A00   /* A <[>          */
#  define   Key_A_Rbr   0x1B00   /* A <]>          */
#  define   Key_A_Ent   0x1C00   /* A <Enter>      */
#  define   Key_A_A     0x1E00   /* A <a>          */
#  define   Key_A_S     0x1F00   /* A <s>          */
#  define   Key_A_D     0x2000   /* A <d>          */
#  define   Key_A_F     0x2100   /* A <f>          */
#  define   Key_A_G     0x2200   /* A <g>          */
#  define   Key_A_H     0x2300   /* A <h>          */
#  define   Key_A_J     0x2400   /* A <j>          */
#  define   Key_A_K     0x2500   /* A <k>          */
#  define   Key_A_L     0x2600   /* A <l>          */
#  define   Key_A_Smi   0x2700   /* A <;>          */
#  define   Key_A_Quo   0x2800   /* A <'>          */
#  define   Key_A_Grv   0x2900   /* A <`>          */
#  define   Key_A_Bsl   0x2B00   /* A <\>          */
#  define   Key_A_Z     0x2C00   /* A <z>          */
#  define   Key_A_X     0x2D00   /* A <x>          */
#  define   Key_A_C     0x2E00   /* A <c>          */
#  define   Key_A_V     0x2F00   /* A <v>          */
#  define   Key_A_B     0x3000   /* A <b>          */
#  define   Key_A_N     0x3100   /* A <n>          */
#  define   Key_A_M     0x3200   /* A <m>          */
#  define   Key_A_5Num  0x4C00   /* a <5>Num    ** */
#  define   Key_A_F1    0x6800   /* A <F1>         */
#  define   Key_A_F2    0x6900   /* A <F2>         */
#  define   Key_A_F3    0x6A00   /* A <F3>         */
#  define   Key_A_F4    0x6B00   /* A <F4>         */
#  define   Key_A_F5    0x6C00   /* A <F5>         */
#  define   Key_A_F6    0x6D00   /* A <F6>         */
#  define   Key_A_F7    0x6E00   /* A <F7>         */
#  define   Key_A_F8    0x6F00   /* A <F8>         */
#  define   Key_A_F9    0x7000   /* A <F9>         */
#  define   Key_A_F10   0x7100   /* A <F10>        */
#  define   Key_A_1     0x7800   /* A <1>          */
#  define   Key_A_2     0x7900   /* A <2>          */
#  define   Key_A_3     0x7A00   /* A <3>          */
#  define   Key_A_4     0x7B00   /* A <4>          */
#  define   Key_A_5     0x7C00   /* A <5>          */
#  define   Key_A_6     0x7D00   /* A <6>          */
#  define   Key_A_7     0x7E00   /* A <7>          */
#  define   Key_A_8     0x7F00   /* A <8>          */
#  define   Key_A_9     0x8000   /* A <9>          */
#  define   Key_A_0     0x8100   /* A <0>          */
#  define   Key_A_Min   0x8200   /* A <->          */
#  define   Key_A_Equ   0x8300   /* A <=>          */
#  define   Key_A_F11   0x8B00   /* A <F11>     ** */
#  define   Key_A_F12   0x8C00   /* A <F12>     ** */
#  define   Key_A_Home  0x9700   /* A <Home>    ** */
#  define   Key_A_Up    0x9800   /* A <Up>      ** */
#  define   Key_A_PgUp  0x9900   /* A <PgUp>    ** */
#  define   Key_A_Lft   0x9B00   /* A <Left>    ** */
#  define   Key_A_Rgt   0x9D00   /* A <Right>   ** */
#  define   Key_A_End   0x9F00   /* A <End>     ** */
#  define   Key_A_Dwn   0xA000   /* A <Dwn>     ** */
#  define   Key_A_PgDn  0xA100   /* A <PgDn>    ** */
#  define   Key_A_Ins   0xA200   /* A <Ins>     ** */
#  define   Key_A_Del   0xA300   /* A <Del>     ** */
#  define   Key_A_EntG  0xA600   /* A <Enter>Gry** */
#endif   /* _TCXLcod_ : End of TCXLcod.h */
