/*=====[ The TesSeRact(TM) CXL User Interface Development System ]======*
 | Copyright (c) 1987-1990, Innovative Data Concepts. All Rights Reserved
 |
 | This Library is part of IDC's TesSeRact Development Tools product
 | line. For information about other IDC products, call 1-215-884-3373.
 *----------------------------------------------------------------------*
 | <TCXLerr.h> : Definitions of TCXL error and diagnostic codes.
 *-------------------------------[ NOTES ]------------------------------*
 | 1) These values are inherited from CXL and WILL CHANGE for TCXL 6.0.
 | 2) This file is included by <TCXLwin.h>.
 | 3) TCXL 5.5 functions no longer return these values. They set global
 |    TclxErr and return the following.
 |       ERR_ESC = 1    [Esc] pressed
 |       ERR_NUL = 0    for success
 |       ERR_ARG = -1   argument failure
 |       ERR_MEM = -2   allocation failure
 *----------------------------------------------------------------------*
 | PGS : $Id: tcxlerr.h 5.51 90/10/01 00:00:00 MLM Release Locker: MLM $
 | $Log:	tcxlerr.h $
 | Revision 5.51  90/10/01  00:00:00  MLM
 | TCXL 5.51
 | 
 *======================================================================*/
#ifndef  _TCXLerr_
#  define   _TCXLerr_ 1          /*- TcxlErr error-codes ------------*/
#  define   W_ESCPRESS  0x01     /* Escape key was pressed           */
#  define   W_ALLOCERR  0x02     /* memory allocation error          */
#  define   W_NOTFOUND  0x03     /* record not found                 */
#  define   W_NOACTIVE  0x04     /* no active window                 */
#  define   W_INVCOORD  0x05     /* invalid coordinates              */
#  define   W_INVFORMT  0x06     /* invalid format string            */
#  define   W_NOINPDEF  0x07     /* no input fields defined          */
#  define   W_STRLONG   0x08     /* string too long for window       */
#  define   W_INVBTYPE  0x09     /* invalid box type                 */
#  define   W_NOBORDER  0x0A     /* no window border                 */
#  define   W_NOHIDDEN  0x0B     /* no hidden windows                */
#  define   W_NOTHIDD   0x0C     /* window is not hidden             */
#  define   W_NOSELECT  0x0D     /* no selectable menu items         */
#  define   W_NOITMDEF  0x0E     /* no menu items defined            */
#  define   W_NOMNUEND  0x0F     /* no end of menu specified         */
#  define   W_NOMNUDEF  0x10     /* no menu defined                  */
#  define   W_NOMNUBEG  0x11     /* no begin of menu specified       */
#  define   W_NOFRMDEF  0x12     /* no form defined                  */
#  define   W_NOFRMBEG  0x13     /* no begin of form specified       */
#  define   W_NOHLPDEF  0x14     /* no help record defined           */
#  define   W_HLPSTKOV  0x15     /* help stack overflow              */
#  define   W_HLPSTKUN  0x16     /* help stack underflow             */
#  define   W_DOSERROR  0x17     /* DOS error                        */
#  define   W_NOMATCH   0x18     /* no files matched input filespec  */
#  define   W_INVTAGID  0x19     /* invalid tag identifier           */
#  define   W_INVPATH   0x1A     /* path invalid or not found        */
#endif   /* _TCXLerr_ : End of TCXLerr.h */
