/*=====[ The TesSeRact(TM) CXL User Interface Development System ]======*
 | Copyright (c) 1987-1990, Innovative Data Concepts. All Rights Reserved
 |
 | This Library is part of IDC's TesSeRact Development Tools product
 | line. For information about other IDC products, call 1-215-884-3373.
 *----------------------------------------------------------------------*
 | TCXLprn.h: Definitions and prototypes for TCXL printer functions.
 *----------------------------------------------------------------------*
 | PGS : $Id: tcxlprn.h 5.51 90/10/01 00:00:00 MLM Release Locker: MLM $
 | $Log:	tcxlprn.h $
 | Revision 5.51  90/10/01  00:00:00  MLM
 | TCXL 5.51
 | 
 *======================================================================*/
#ifndef  _TCXLprn_
#  define   _TCXLprn_ 1
#  ifndef   _TCXLdef_
#     include  <TCXLdef.h>
#  endif
/*--------[ printer Escape codes for Epson compatible printers ]--------*
 | Example:  lprints(L_BFON"This is bold printing"L_BFOFF);
 */
#define  L_BFOFF     "\033F"     /* turns bold faced printing off  */
#define  L_BFON      "\033E"     /* turns bold faced printing on   */
#define  L_DWOFF     "\033W0"    /* turns double wide printing off */
#define  L_DWON      "\033W1"    /* turns double wide printing on  */
#define  L_ELITE     "\033M"     /* sets printer in 12 CPI mode    */
#define  L_INIT      "\033@"     /* initializes printer            */
#define  L_ITALOFF   "\0335"     /* turns italicized printing off  */
#define  L_ITALON    "\0334"     /* turns italicized printing on   */
#define  L_PICA      "\033P"     /* sets printer in 10 CPI mode    */
#define  L_ULOFF     "\033-0"    /* turns underlined printing off  */
#define  L_ULON      "\033-1"    /* turns underlined printing on   */

/*------------------------[ function prototypes ]-----------------------*/

#ifdef __cplusplus            /* no mangling, please */
   extern "C" {
#endif
VOID  PAS   _LPputC(IntT ch);
VOID        lcrlf(NOARG);
VOID        lprintc(IntT ch);
VOID  CDC   lprintf(ChrP fs, ...);
VOID  CTYP  lprintn(ChrP ps, IntT nc);
VOID  CTYP  lprintns(ChrP ps, IntT nc);
VOID  CTYP  lprints(ChrP ps);
VOID  CTYP  lprintsb(ChrP ps, IntT nr);
VOID  CTYP  lprintsu(ChrP ps);
VOID  CTYP  scrndump(NOARG);
VOID  CTYP  windump(IntT sr, IntT sc, IntT er, IntT ec);
#define  lcrlf()  lprintc(0x0A)
#define  lprintc(c)  _LPputC(c);
#ifdef __cplusplus
   }
#endif
#endif   /* _TCXLprn -- End of TCXLprn.h */
